var dataset = properties.get("dataset");

recipe.addEval("Coverage");
recipe.addEval("NDCG");
recipe.addEval("HLUtility");
recipe.addEval("MAE");
recipe.addEval("RMSE");

importPackage(org.grouplens.lenskit);
importPackage(org.grouplens.lenskit.params);
importPackage(org.grouplens.lenskit.norm);
importPackage(org.grouplens.lenskit.baseline);
importPackage(org.grouplens.lenskit.util);
importPackage(org.grouplens.lenskit.knn);
importPackage(org.grouplens.lenskit.knn.params);
importPackage(org.grouplens.lenskit.knn.item);
importPackage(org.grouplens.lenskit.knn.user);
importPackage(org.grouplens.lenskit.svd);
importPackage(org.grouplens.lenskit.svd.params);

var maxRating = 5;
var minRating = 1;
if (/ml-10?m/.test(dataset))
  minRating = 0.5;

if (dataset != "ymusic") {
  var uu = recipe.addAlgorithm();
  uu.name = "User-User"
  uu.preload = true;
  uu.factory.set(MinRating, minRating);
  uu.factory.set(MaxRating, maxRating);
  uu.factory.setComponent(RatingPredictor, UserUserRatingPredictor);
  uu.factory.set(NeighborhoodSize, 50);
  uu.factory.setComponent(UserSimilarity, Similarity, CosineSimilarity);
  uu.factory.setComponent(BaselinePredictor, ItemUserMeanPredictor);
  uu.factory.setComponent(NormalizerBaseline, BaselinePredictor, UserMeanPredictor);
  uu.factory.setComponent(UserRatingVectorNormalizer, VectorNormalizer, BaselineSubtractingNormalizer);
}

var ii = recipe.addAlgorithm();
ii.name = "Item-Item"
ii.factory.set(MinRating, minRating);
ii.factory.set(MaxRating, maxRating);
ii.factory.setComponent(RatingPredictor, ItemItemRatingPredictor);
ii.factory.set(NeighborhoodSize, 30);
ii.factory.setComponent(ItemSimilarity, Similarity, CosineSimilarity);
ii.factory.setComponent(BaselinePredictor, ItemUserMeanPredictor);
ii.factory.setComponent(UserRatingVectorNormalizer, VectorNormalizer, BaselineSubtractingNormalizer);

var svd = recipe.addAlgorithm();
svd.name = "FunkSVD";
svd.factory.set(MinRating, minRating);
svd.factory.set(MaxRating, maxRating);
svd.factory.setComponent(RatingPredictor, FunkSVDRatingPredictor);
svd.factory.set(FeatureCount, 40);
svd.factory.setComponent(BaselinePredictor, ItemUserMeanPredictor);
svd.factory.setComponent(ClampingFunction, DoubleFunction, RatingRangeClamp);
svd.factory.set(MeanSmoothing, 25);
svd.factory.set(IterationCount, 100);
